// Teil des Projekts "LinADT" -- Lineare abstrakte Datentypen Keller und Schlange
// R. Krell (www.r-krell.de); Javatexte zum Skript "keller-und-schlange_(r-krell).pdf", 22.12.2006

public class ADT_Keller1 implements ADT_Speicher
// Version 1: Keller in statischer Implementation mit einer Reihung
{
  protected Object[] reihung;  // protected statt private fr sptere Vererbung
  protected int kopf;
  private final int MAX = 100; // Maximale Zahl der Kellerelemet = statische Gre
  
  public ADT_Keller1()         // Konstruktor fr neuen, leeren Keller
  {
    reihung = new Object[MAX]; // Anlegen der statischen Datenstruktur
    kopf = -1;                 // negativ: noch kein oberstes Element!
  }
  
  public void rein (Object element) // bergebenes Element kommt in Speicher
  {
    kopf++;
    reihung[kopf] = element;   // das letzte eingekellerte (=oberste) Element
  }                            // steht am Index kopf
  
  public boolean istLeer()     // sagt, ob der Speicher leer ist
  {
    return (kopf == -1);
  }
  
  public Object zeige()        // zeigt oberstes Element ohne ndern des Speichers
  {
    return (reihung[kopf]);
  }
  
  public Object raus()         // zeigt oberstes El. und lscht es aus dem Speicher
  {
    kopf--;                    // hier war der Fehler: die Vorsorge
     // fr die Schlange hatte mit kopf=(kopf+MAX-1)%MAX (statt kopf--) dafr
     // gesorgt, dass kopf nie -1 (sondern stattdessen +99) wurde => istLeer funktionierte
     // nicht mehr! Also entweder hier wieder -- oder istLeer ndern!
    return (reihung[kopf+1]);
  }
}

