// Teil des Projekts typisierte lineare abstrakte Datentypen -- nur ab Java (1.)5
// R. Krell (www.r-krell.de) -- 21.12.2006 -- Java JDK 1.5+ ntig

public class TADT_Keller1<Elementtyp> extends TADT_StatSpeicherMitEndzugriff<Elementtyp>
// Keller als Erbe der abstrakten Oberklasse mit zustzl. Definitionen
{

  public TADT_Keller1()        // Konstruktor fr neuen, leeren Keller
  {
    super();                   // hier kann und darf kein Typ bergeben werden, wie etwa
                               // super<Elementtyp>();
                               // Wird offenbar automatisch vonJava richtig gemacht.
  }
  
  public void rein (Elementtyp element) // bergebenes Element kommt in Speicher
  {
    kopf=(kopf+1)%MAX;         // der Keller wchst zwar nur von 0 an nach rechts, sodass kopf++
                               // scheinbar reicht. Aber der leere Keller beginnt wegen ererbtem raus
                               // nicht bei -1, sondern bei MAX-1, sodass beim Schritt vom leeren Keller
                               // zum Keller mit einem Element diese Rechnung ntig ist.
    reihung[kopf] = element;   // das letzte eingekellerte (=oberste) Element
  }                            // steht am Index kopf
  
  public boolean istLeer()     // sagt, ob der Speicher leer ist
  {
    return (kopf == MAX-1);    // vgl. Konstruktor und raus (aus Oberklasse)
  }
}

