// Teil des Projekts typisierte lineare abstrakte Datentypen -- nur ab Java (1.)5
// R. Krell (www.r-krell.de) -- 21.12.2006 -- Java JDK 1.5+ ntig

import java.awt.*;
import java.awt.event.*;

public class TADT_Oberflaeche extends Frame
// Oberflche zum Testen der typisierten Keller und Schlangen;
// Die Compiler-Warnung, dass diese Klasse keine serialVersionUID hat, kann ignoriert werden.
{
  TextField eingabe = new TextField("",8);
  TextArea ausgabe = new TextArea("Zuerst einen Elemettyp whlen, dann LinADT erzeugen!\n",10,95);
  CheckboxGroup cbg = new CheckboxGroup();
  Checkbox cbZahl, cbZchn, cbText;
  Button knKellerReih, knSchlangeReih,
    knKellerDyn, knSchlangeDyn,
    knRein, knRaus, knZeige, knLeer; // Knpfe definieren
    
  final int NDEF = 0;       // nicht definiert: noch kein Elementtyp ausgewhlt
  final int ZAHL = 1;
  final int ZCHN = 2;
  final int TEXT = 3;
  int elementTypNr = NDEF;  // merkt sich den Elementtyp des erzeugten Datenspeichers und
                            // dient spter zur Auswahl des richtigen Datenspeichers
  
  TADT_Speicher<Double> datenSpeicherZahl;     // Zwar wre es hier noch mglich, statt drei
  TADT_Speicher<Character> datenSpeicherZchn;  // spezieller Speicher einen allgemein typisierten
  TADT_Speicher<String> datenSpeicherText;     // TADT_Speicher<?> datenSpeicher zu definieren,
    // aber in diesen knnten spter keine konkreten Elemente eines bestimmten Typs mit rein
    // eingefllt werden: der Compiler meldet Fehler wegen nichtbereinstimmender Typen!

  private void richteFensterEin() // Fenster initalisieren und beschreiben
  {
    //WindowsListener hinzufgen, damit Schlieknopf funktioniert
    addWindowListener (    
      new WindowAdapter ()
      {
        public void windowClosing (WindowEvent ereignis)
        {                
          setVisible (false);
          dispose();  
          System.exit(0);
        }
      }
    ); // runde Klammer vom Windowlistener geschlossen;  
    
    setTitle("Testprogramm fr typisierte lineare abstrakte Datentypen -- www.r-krell.de"); // Fenster mit Titel versehen
    setSize (720,278); // Fenstergre (Breite und Hhe in Pixeln) festlegen
  }  
   
  private void richteRadiobuttonsEin()
  {
    cbZahl = new Checkbox ("Zahl", cbg, false);
    cbZchn = new Checkbox ("Zeichen", cbg, false);
    cbText = new Checkbox ("Text", cbg, true);
  }
  
  private int frageRadiobuttonsAb()
  {
    int ergebnis = NDEF;
    if (cbZahl.getState())
    {
      ergebnis = ZAHL;
    }
    else if (cbZchn.getState())
    {
      ergebnis = ZCHN;
    }
    else if (cbText.getState())
    {
      ergebnis = TEXT;
    }
    return (ergebnis);
  }
  
  private void richteKnpfeEin()
  {     
    // Knpfe erzeugen:
    knKellerReih     = new Button ("Keller (stat., mit Reihung)");
    knKellerDyn      = new Button ("Keller (dyn., mit Knoten)");
    knSchlangeReih   = new Button ("Schlange (stat.)");
    knSchlangeDyn    = new Button ("Schlange (dyn.)");
    knRein           = new Button ("rein");
    knRaus           = new Button ("raus");
    knZeige          = new Button ("zeige");
    knLeer           = new Button ("istLeer ?");
        
    //Funktion der Knpfe festlegen:
    
    knKellerReih.addActionListener (
      new ActionListener () 
      { 
        public void actionPerformed (ActionEvent e) 
        { 
          String aus = "** Probleme beim Anlegen des neuen stat. typisierten Kellers mit Reihung **";
          elementTypNr = frageRadiobuttonsAb(); // Der gewhlte Typ wird global gemerkt und dient
            // sowohl hier zur Auswahl des richtigen Speichers als auch spter bei rein, raus und
            // zeige zur richtigen Umwandlung der Eingabe bzw. richtigen Interpretation des Elements
          switch (elementTypNr)
          {
            case ZAHL: datenSpeicherZahl = new TADT_Keller1<Double>();
                       aus = "neuer, leerer stat. Keller mit Reihung fr Kommazahlen angelegt"; break;
            case ZCHN: datenSpeicherZchn = new TADT_Keller1<Character>();
                       aus = "neuer, leerer stat. Keller mit Reihung fr Schriftzeichen angelegt"; break;
            case TEXT: datenSpeicherText = new TADT_Keller1<String>();
                       aus = "neuer, leerer stat. Keller mit Reihung fr Zeichenketten angelegt"; break;
          }
          ausgabe.append (aus+"\n");
          eingabe.requestFocus(); // aktviert die Eingabezeile,
           // sodass knftige Tastatureingaben automatisch in der eingabe landen
          eingabe.selectAll(); // macht evtl. Text in der Eingabezeile blau,
           // sodass alter Text automatisch berschrieben wird
        } 
      });

    knKellerDyn.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          String aus = "** Probleme beim Anlegen des neuen dyn. typisierten Kellers mit Knoten **";
          elementTypNr = frageRadiobuttonsAb();
          switch (elementTypNr)
          {
            case ZAHL: datenSpeicherZahl = new TADT_Keller<Double>();
                       aus = "neuer, leerer dyn. Keller mit Knoten fr Kommazahlen angelegt"; break;
            case ZCHN: datenSpeicherZchn = new TADT_Keller<Character>();
                       aus = "neuer, leerer dyn. Keller mit Knoten fr Schriftzeichen angelegt"; break;
            case TEXT: datenSpeicherText = new TADT_Keller<String>();
                       aus = "neuer, leerer dyn. Keller mit Knoten fr Zeichenketten angelegt"; break;
          }
          ausgabe.append (aus+"\n");
          eingabe.requestFocus();
          eingabe.selectAll();
        }
      });

    knSchlangeReih.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          String aus = "** Probleme beim Anlegen der neuen stat. typisierten Schlange mit Reihung **";
          elementTypNr = frageRadiobuttonsAb();
          switch (elementTypNr)
          {
            case ZAHL: datenSpeicherZahl = new TADT_Schlange1<Double>();
                       aus = "neue, leere stat. Schlange mit Reihung fr Kommazahlen angelegt"; break;
            case ZCHN: datenSpeicherZchn = new TADT_Schlange1<Character>();
                       aus = "neue, leere stat. Schlange mit Reihung fr Schriftzeichen angelegt"; break;
            case TEXT: datenSpeicherText = new TADT_Schlange1<String>();
                       aus = "neue, leere stat. Schlange mit Reihung fr Schriftzeichen angelegt"; break;
          }
          ausgabe.append (aus+"\n");
          eingabe.requestFocus();
          eingabe.selectAll();
        } 
      });  

    knSchlangeDyn.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          String aus = "** Probleme beim Anlegen der neuen dyn. typisierten Schlange mit Knoten **";
          elementTypNr = frageRadiobuttonsAb();
          switch (elementTypNr)
          {
            case ZAHL: datenSpeicherZahl = new TADT_Schlange<Double>();
                       aus = "neue, leere dyn. Schlange mit Knoten fr Kommazahlen angelegt"; break;
            case ZCHN: datenSpeicherZchn = new TADT_Schlange<Character>();
                       aus = "neue, leere dyn. Schlange mit Knoten fr Schriftzeichen angelegt"; break;
            case TEXT: datenSpeicherText = new TADT_Schlange<String>();
                       aus = "neue, leere dyn. Schlange mit Knoten fr Zeichenketten angelegt"; break;
          }
          ausgabe.append (aus+"\n");
          eingabe.requestFocus();
          eingabe.selectAll();
        }
      });    

    knRein.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          String ein = eingabe.getText();
          if (!ein.equals(""))
          {
            try
            {
              String aus="???";
              switch (elementTypNr)  // Die Eingabe wird in den Typ des Datenspeichers verwandelt.
              {
                case ZAHL: datenSpeicherZahl.rein(Double.parseDouble(ein));
                           aus = "Die Zahl "+ein; break;
                case ZCHN: datenSpeicherZchn.rein(ein.charAt(0)); aus="Das Zeichen '"+ein.charAt(0)+"'"; break;
                case TEXT: datenSpeicherText.rein(ein); aus="Die Zeichenkette \""+ein+"\""; break;
              }
              ausgabe.append (aus+" wurde eingefgt.\n");
            }
            catch (Exception f)
            {
              ausgabe.append ("** Fehler beim Versuch, \""+ein+"\" einzufgen -- "+f+"\n");
            }
          }
          else
          {
            ausgabe.append ("Erst gesuchtes Element eingeben!\n");
          }
          eingabe.requestFocus();
          eingabe.selectAll();
        }       
      });

        
    knRaus.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          Object el = null;
          String aus = "???";
          try
          {
            switch (elementTypNr)  // Das el wird enstprechend dem Datenspeichertyp interpretiert
            {
              case ZAHL: el = datenSpeicherZahl.raus(); aus = "Zahl "+el; break;
              case ZCHN: el = datenSpeicherZchn.raus(); aus = "Zeichen '"+el+"'"; break;
              case TEXT: el = datenSpeicherText.raus(); aus = "Zeichenkette \""+el+"\""; break;
            }
            if (el !=null)
            {
              ausgabe.append (aus+" entfernt!\n");
            }
            else
            {
              ausgabe.append ("** Kein Element zum Entfernen vorhanden/gefunden! **\n");
            }
          }
          catch (Exception f)
          {
            ausgabe.append ("** "+f+"\n");
          }
        }   
      });  
        
    knZeige.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          Object el = null;
          String aus = "???";
          try
          {
            switch (elementTypNr)   // Das el wird enstprechend dem Datenspeichertyp interpretiert
            {
              case ZAHL: el = datenSpeicherZahl.zeige(); aus = "Zahl "+el; break;
              case ZCHN: el = datenSpeicherZchn.zeige(); aus = "Zeichen '"+el+"'"; break;
              case TEXT: el = datenSpeicherText.zeige(); aus = "Zeichenkette \""+el+"\""; break;
            }
            if (el !=null)
            {
              ausgabe.append (aus+" ist vorne/oben.\n");
            }
            else
            {
              ausgabe.append ("** Kein Element zum Anzeigen vorhanden/gefunden! **\n");
            }
          }
          catch (Exception f)
          {
            ausgabe.append ("** "+f+"\n");
          }
        }   
      });  

    knLeer.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          try
          {
            boolean leer=true;
            switch (elementTypNr)   // Auswahl ntig, weil es drei versch. Datenspeicher gibt.
            {
              case ZAHL: leer = datenSpeicherZahl.istLeer(); break;
              case ZCHN: leer = datenSpeicherZchn.istLeer(); break;
              case TEXT: leer = datenSpeicherText.istLeer(); break;
            }
            if (leer)
            {
              ausgabe.append ("Der Speicher ist im Moment leer!\n");
            }
            else
            {
              ausgabe.append ("Der Speicher ist im Moment nicht leer!\n");
            }
          }
          catch (Exception f)
          {
            ausgabe.append ("** "+f+"\n");
          }
        }   
      });  

  } 
   
  public void fhreAus ()
  { 
    richteFensterEin();
    richteRadiobuttonsEin();
    richteKnpfeEin();      
    ausgabe.setEditable(false); // Ausgabe nicht vom Benutzer nderbar
    setLayout (new FlowLayout());

    add (cbZahl);
    add (cbZchn);
    add (cbText);
    add (knKellerReih); 
    add (knKellerDyn);
    add (knSchlangeReih);   
    add (knSchlangeDyn);
    add (new Label("Element:"));
    add (eingabe);
    add (knRein); add (new Label(""));
    add (knLeer); add (new Label(""));
    add (knZeige); add (new Label(""));
    add (knRaus); add (new Label(""));
    add (ausgabe);
    setVisible(true);      
  }   
}
